# _ generateGridNode_GG_rule.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from MainAxisNode import *
from GoOn import *
from Ant import *
from ToSameCircle import *
from Hill import *
from ToNextCircle import *
from World import *
from ASG_AntWorld import *
from GridNode import *
class generateGridNode_GG_rule (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.TestRule = 1
      self.LHS = ASG_AntWorld(parent)

      self.obj1600=GridNode(parent)
      self.obj1600.preAction( self.LHS.CREATE )
      self.obj1600.isGraphObjectVisual = True

      if(hasattr(self.obj1600, '_setHierarchicalLink')):
        self.obj1600._setHierarchicalLink(False)

      # foodParts
      self.obj1600.foodParts.setNone()

      # pheromones
      self.obj1600.pheromones.setNone()

      self.obj1600.GGLabel.setValue(1)
      self.obj1600.GGPivot.setValue(('True', 0))
      self.obj1600.GGPivot.config = 0
      self.obj1600.GGSubTypeMatching.setValue(('True', 0))
      self.obj1600.GGSubTypeMatching.config = 0
      self.obj1600.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(280.0,60.0,self.obj1600)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1600.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1600)
      self.obj1600.postAction( self.LHS.CREATE )

      self.obj1601=GridNode(parent)
      self.obj1601.preAction( self.LHS.CREATE )
      self.obj1601.isGraphObjectVisual = True

      if(hasattr(self.obj1601, '_setHierarchicalLink')):
        self.obj1601._setHierarchicalLink(False)

      # foodParts
      self.obj1601.foodParts.setNone()

      # pheromones
      self.obj1601.pheromones.setNone()

      self.obj1601.GGLabel.setValue(2)
      self.obj1601.GGPivot.setValue(('True', 1))
      self.obj1601.GGPivot.config = 0
      self.obj1601.GGSubTypeMatching.setValue(('True', 1))
      self.obj1601.GGSubTypeMatching.config = 0
      self.obj1601.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(140.0,60.0,self.obj1601)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1601.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1601)
      self.obj1601.postAction( self.LHS.CREATE )

      self.obj1602=ToSameCircle(parent)
      self.obj1602.preAction( self.LHS.CREATE )
      self.obj1602.isGraphObjectVisual = True

      if(hasattr(self.obj1602, '_setHierarchicalLink')):
        self.obj1602._setHierarchicalLink(False)

      self.obj1602.GGLabel.setValue(3)
      self.obj1602.GGPivot.setValue(('True', 0))
      self.obj1602.GGPivot.config = 0
      self.obj1602.GGSubTypeMatching.setValue(('True', 0))
      self.obj1602.GGSubTypeMatching.config = 0
      self.obj1602.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(140.0,60.0,self.obj1602)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1602.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1602)
      self.obj1602.postAction( self.LHS.CREATE )

      self.obj1601.out_connections_.append(self.obj1602)
      self.obj1602.in_connections_.append(self.obj1601)
      self.obj1601.graphObject_.pendingConnections.append((self.obj1601.graphObject_.tag, self.obj1602.graphObject_.tag, [140.0, 60.0, 140.0, 60.0], 0, False))
      self.obj1602.out_connections_.append(self.obj1600)
      self.obj1600.in_connections_.append(self.obj1602)
      self.obj1602.graphObject_.pendingConnections.append((self.obj1602.graphObject_.tag, self.obj1600.graphObject_.tag, [280.0, 60.0, 140.0, 60.0], 0, False))

      self.RHS = ASG_AntWorld(parent)

      self.obj1604=GridNode(parent)
      self.obj1604.preAction( self.RHS.CREATE )
      self.obj1604.isGraphObjectVisual = True

      if(hasattr(self.obj1604, '_setHierarchicalLink')):
        self.obj1604._setHierarchicalLink(False)

      # foodParts
      self.obj1604.foodParts.setValue(0)

      # pheromones
      self.obj1604.pheromones.setValue(0)

      self.obj1604.GGLabel.setValue(1)
      self.obj1604.GGPivot.setValue(('True', 1))
      self.obj1604.GGPivot.config = 0
      self.obj1604.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,60.0,self.obj1604)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1604.graphObject_ = new_obj
      self.obj16040= AttrCalc()
      self.obj16040.Copy=ATOM3Boolean()
      self.obj16040.Copy.setValue(('Copy from LHS', 1))
      self.obj16040.Copy.config = 0
      self.obj16040.Specify=ATOM3Constraint()
      self.obj16040.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1604.GGset2Any['foodParts']= self.obj16040
      self.obj16041= AttrCalc()
      self.obj16041.Copy=ATOM3Boolean()
      self.obj16041.Copy.setValue(('Copy from LHS', 1))
      self.obj16041.Copy.config = 0
      self.obj16041.Specify=ATOM3Constraint()
      self.obj16041.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1604.GGset2Any['pheromones']= self.obj16041

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1604)
      self.obj1604.postAction( self.RHS.CREATE )

      self.obj1605=GridNode(parent)
      self.obj1605.preAction( self.RHS.CREATE )
      self.obj1605.isGraphObjectVisual = True

      if(hasattr(self.obj1605, '_setHierarchicalLink')):
        self.obj1605._setHierarchicalLink(False)

      # foodParts
      self.obj1605.foodParts.setValue(0)

      # pheromones
      self.obj1605.pheromones.setValue(0)

      self.obj1605.GGLabel.setValue(2)
      self.obj1605.GGPivot.setValue(('True', 0))
      self.obj1605.GGPivot.config = 0
      self.obj1605.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(80.0,60.0,self.obj1605)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1605.graphObject_ = new_obj
      self.obj16050= AttrCalc()
      self.obj16050.Copy=ATOM3Boolean()
      self.obj16050.Copy.setValue(('Copy from LHS', 1))
      self.obj16050.Copy.config = 0
      self.obj16050.Specify=ATOM3Constraint()
      self.obj16050.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1605.GGset2Any['foodParts']= self.obj16050
      self.obj16051= AttrCalc()
      self.obj16051.Copy=ATOM3Boolean()
      self.obj16051.Copy.setValue(('Copy from LHS', 1))
      self.obj16051.Copy.config = 0
      self.obj16051.Specify=ATOM3Constraint()
      self.obj16051.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1605.GGset2Any['pheromones']= self.obj16051

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1605)
      self.obj1605.postAction( self.RHS.CREATE )

      self.obj1606=GridNode(parent)
      self.obj1606.preAction( self.RHS.CREATE )
      self.obj1606.isGraphObjectVisual = True

      if(hasattr(self.obj1606, '_setHierarchicalLink')):
        self.obj1606._setHierarchicalLink(False)

      # foodParts
      self.obj1606.foodParts.setValue(0)

      # pheromones
      self.obj1606.pheromones.setValue(0)

      self.obj1606.GGLabel.setValue(4)
      self.obj1606.GGPivot.setValue(('True', 0))
      self.obj1606.GGPivot.config = 0
      self.obj1606.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,140.0,self.obj1606)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1606.graphObject_ = new_obj
      self.obj16060= AttrCalc()
      self.obj16060.Copy=ATOM3Boolean()
      self.obj16060.Copy.setValue(('Copy from LHS', 0))
      self.obj16060.Copy.config = 0
      self.obj16060.Specify=ATOM3Constraint()
      self.obj16060.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1606.GGset2Any['foodParts']= self.obj16060
      self.obj16061= AttrCalc()
      self.obj16061.Copy=ATOM3Boolean()
      self.obj16061.Copy.setValue(('Copy from LHS', 0))
      self.obj16061.Copy.config = 0
      self.obj16061.Specify=ATOM3Constraint()
      self.obj16061.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1606.GGset2Any['pheromones']= self.obj16061

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1606)
      self.obj1606.postAction( self.RHS.CREATE )

      self.obj1607=ToNextCircle(parent)
      self.obj1607.preAction( self.RHS.CREATE )
      self.obj1607.isGraphObjectVisual = True

      if(hasattr(self.obj1607, '_setHierarchicalLink')):
        self.obj1607._setHierarchicalLink(False)

      self.obj1607.GGLabel.setValue(5)
      self.obj1607.GGPivot.setValue(('True', 0))
      self.obj1607.GGPivot.config = 0
      self.obj1607.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(200.0,60.0,self.obj1607)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1607.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1607)
      self.obj1607.postAction( self.RHS.CREATE )

      self.obj1608=ToSameCircle(parent)
      self.obj1608.preAction( self.RHS.CREATE )
      self.obj1608.isGraphObjectVisual = True

      if(hasattr(self.obj1608, '_setHierarchicalLink')):
        self.obj1608._setHierarchicalLink(False)

      self.obj1608.GGLabel.setValue(3)
      self.obj1608.GGPivot.setValue(('True', 0))
      self.obj1608.GGPivot.config = 0
      self.obj1608.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(80.0,60.0,self.obj1608)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1608.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1608)
      self.obj1608.postAction( self.RHS.CREATE )

      self.obj1604.out_connections_.append(self.obj1607)
      self.obj1607.in_connections_.append(self.obj1604)
      self.obj1604.graphObject_.pendingConnections.append((self.obj1604.graphObject_.tag, self.obj1607.graphObject_.tag, [200.0, 60.0, 200.0, 60.0], 0, False))
      self.obj1605.out_connections_.append(self.obj1608)
      self.obj1608.in_connections_.append(self.obj1605)
      self.obj1605.graphObject_.pendingConnections.append((self.obj1605.graphObject_.tag, self.obj1608.graphObject_.tag, [80.0, 60.0, 80.0, 60.0], 0, False))
      self.obj1607.out_connections_.append(self.obj1606)
      self.obj1606.in_connections_.append(self.obj1607)
      self.obj1607.graphObject_.pendingConnections.append((self.obj1607.graphObject_.tag, self.obj1606.graphObject_.tag, [200.0, 140.0, 200.0, 60.0], 0, False))
      self.obj1608.out_connections_.append(self.obj1604)
      self.obj1604.in_connections_.append(self.obj1608)
      self.obj1608.graphObject_.pendingConnections.append((self.obj1608.graphObject_.tag, self.obj1604.graphObject_.tag, [200.0, 60.0, 80.0, 60.0], 0, False))

      self.NAC = ASG_AntWorld(parent)

      self.obj1610=GridNode(parent)
      self.obj1610.preAction( self.NAC.CREATE )
      self.obj1610.isGraphObjectVisual = True

      if(hasattr(self.obj1610, '_setHierarchicalLink')):
        self.obj1610._setHierarchicalLink(False)

      # foodParts
      self.obj1610.foodParts.setNone()

      # pheromones
      self.obj1610.pheromones.setNone()

      self.obj1610.GGLabel.setValue(1)
      self.obj1610.GGSubTypeMatching.setValue(('True', 0))
      self.obj1610.GGSubTypeMatching.config = 0
      self.obj1610.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(220.0,40.0,self.obj1610)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1610.graphObject_ = new_obj
      self.obj16100= AttrCalc()
      self.obj16100=ATOM3Boolean()
      self.obj16100.setValue(('Set to any', 1))
      self.obj16100.config = 0
      self.obj1610.GGset2Any['foodParts']= self.obj16100
      self.obj16101= AttrCalc()
      self.obj16101=ATOM3Boolean()
      self.obj16101.setValue(('Set to any', 1))
      self.obj16101.config = 0
      self.obj1610.GGset2Any['pheromones']= self.obj16101

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1610)
      self.obj1610.postAction( self.NAC.CREATE )

      self.obj1611=GridNode(parent)
      self.obj1611.preAction( self.NAC.CREATE )
      self.obj1611.isGraphObjectVisual = True

      if(hasattr(self.obj1611, '_setHierarchicalLink')):
        self.obj1611._setHierarchicalLink(False)

      # foodParts
      self.obj1611.foodParts.setValue(0)

      # pheromones
      self.obj1611.pheromones.setValue(0)

      self.obj1611.GGLabel.setValue(4)
      self.obj1611.GGSubTypeMatching.setValue(('True', 0))
      self.obj1611.GGSubTypeMatching.config = 0
      self.obj1611.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(220.0,120.0,self.obj1611)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1611.graphObject_ = new_obj
      self.obj16110= AttrCalc()
      self.obj16110=ATOM3Boolean()
      self.obj16110.setValue(('Set to any', 0))
      self.obj16110.config = 0
      self.obj1611.GGset2Any['foodParts']= self.obj16110
      self.obj16111= AttrCalc()
      self.obj16111=ATOM3Boolean()
      self.obj16111.setValue(('Set to any', 0))
      self.obj16111.config = 0
      self.obj1611.GGset2Any['pheromones']= self.obj16111

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1611)
      self.obj1611.postAction( self.NAC.CREATE )

      self.obj1612=ToNextCircle(parent)
      self.obj1612.preAction( self.NAC.CREATE )
      self.obj1612.isGraphObjectVisual = True

      if(hasattr(self.obj1612, '_setHierarchicalLink')):
        self.obj1612._setHierarchicalLink(False)

      self.obj1612.GGLabel.setValue(5)
      self.obj1612.GGSubTypeMatching.setValue(('True', 0))
      self.obj1612.GGSubTypeMatching.config = 0
      self.obj1612.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(220.0,75.0,self.obj1612)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1612.graphObject_ = new_obj

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1612)
      self.obj1612.postAction( self.NAC.CREATE )

      self.obj1610.out_connections_.append(self.obj1612)
      self.obj1612.in_connections_.append(self.obj1610)
      self.obj1610.graphObject_.pendingConnections.append((self.obj1610.graphObject_.tag, self.obj1612.graphObject_.tag, [220.0, 40.0, 220.0, 75.0], 0, False))
      self.obj1612.out_connections_.append(self.obj1611)
      self.obj1611.in_connections_.append(self.obj1612)
      self.obj1612.graphObject_.pendingConnections.append((self.obj1612.graphObject_.tag, self.obj1611.graphObject_.tag, [220.0, 120.0, 220.0, 40.0], 0, False))

   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      for conn in node.out_connections_:
          if isinstance(conn, ToNextCircle):
              return False
      return True
      
      

   def action(self, graphID, isograph, atom3i):
      pass

