# _ connectNodesInSameCircle_GG_rule.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from MainAxisNode import *
from GoOn import *
from Ant import *
from ToSameCircle import *
from Hill import *
from ToNextCircle import *
from World import *
from ASG_AntWorld import *
from GridNode import *
class connectNodesInSameCircle_GG_rule (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 2)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.TestRule = 1
      self.LHS = ASG_AntWorld(parent)

      self.obj1629=GridNode(parent)
      self.obj1629.preAction( self.LHS.CREATE )
      self.obj1629.isGraphObjectVisual = True

      if(hasattr(self.obj1629, '_setHierarchicalLink')):
        self.obj1629._setHierarchicalLink(False)

      # foodParts
      self.obj1629.foodParts.setNone()

      # pheromones
      self.obj1629.pheromones.setNone()

      self.obj1629.GGLabel.setValue(1)
      self.obj1629.GGPivot.setValue(('True', 0))
      self.obj1629.GGPivot.config = 0
      self.obj1629.GGSubTypeMatching.setValue(('True', 0))
      self.obj1629.GGSubTypeMatching.config = 0
      self.obj1629.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(60.0,100.0,self.obj1629)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1629.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1629)
      self.obj1629.postAction( self.LHS.CREATE )

      self.obj1630=GridNode(parent)
      self.obj1630.preAction( self.LHS.CREATE )
      self.obj1630.isGraphObjectVisual = True

      if(hasattr(self.obj1630, '_setHierarchicalLink')):
        self.obj1630._setHierarchicalLink(False)

      # foodParts
      self.obj1630.foodParts.setNone()

      # pheromones
      self.obj1630.pheromones.setNone()

      self.obj1630.GGLabel.setValue(2)
      self.obj1630.GGPivot.setValue(('True', 0))
      self.obj1630.GGPivot.config = 0
      self.obj1630.GGSubTypeMatching.setValue(('True', 0))
      self.obj1630.GGSubTypeMatching.config = 0
      self.obj1630.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,100.0,self.obj1630)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1630.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1630)
      self.obj1630.postAction( self.LHS.CREATE )

      self.obj1631=GridNode(parent)
      self.obj1631.preAction( self.LHS.CREATE )
      self.obj1631.isGraphObjectVisual = True

      if(hasattr(self.obj1631, '_setHierarchicalLink')):
        self.obj1631._setHierarchicalLink(False)

      # foodParts
      self.obj1631.foodParts.setNone()

      # pheromones
      self.obj1631.pheromones.setNone()

      self.obj1631.GGLabel.setValue(3)
      self.obj1631.GGPivot.setValue(('True', 0))
      self.obj1631.GGPivot.config = 0
      self.obj1631.GGSubTypeMatching.setValue(('True', 1))
      self.obj1631.GGSubTypeMatching.config = 0
      self.obj1631.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(60.0,160.0,self.obj1631)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1631.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1631)
      self.obj1631.postAction( self.LHS.CREATE )

      self.obj1632=GridNode(parent)
      self.obj1632.preAction( self.LHS.CREATE )
      self.obj1632.isGraphObjectVisual = True

      if(hasattr(self.obj1632, '_setHierarchicalLink')):
        self.obj1632._setHierarchicalLink(False)

      # foodParts
      self.obj1632.foodParts.setNone()

      # pheromones
      self.obj1632.pheromones.setNone()

      self.obj1632.GGLabel.setValue(4)
      self.obj1632.GGPivot.setValue(('True', 0))
      self.obj1632.GGPivot.config = 0
      self.obj1632.GGSubTypeMatching.setValue(('True', 1))
      self.obj1632.GGSubTypeMatching.config = 0
      self.obj1632.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,160.0,self.obj1632)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1632.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1632)
      self.obj1632.postAction( self.LHS.CREATE )

      self.obj1633=ToNextCircle(parent)
      self.obj1633.preAction( self.LHS.CREATE )
      self.obj1633.isGraphObjectVisual = True

      if(hasattr(self.obj1633, '_setHierarchicalLink')):
        self.obj1633._setHierarchicalLink(False)

      self.obj1633.GGLabel.setValue(6)
      self.obj1633.GGPivot.setValue(('True', 0))
      self.obj1633.GGPivot.config = 0
      self.obj1633.GGSubTypeMatching.setValue(('True', 0))
      self.obj1633.GGSubTypeMatching.config = 0
      self.obj1633.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(60.0,130.0,self.obj1633)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1633.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1633)
      self.obj1633.postAction( self.LHS.CREATE )

      self.obj1634=ToNextCircle(parent)
      self.obj1634.preAction( self.LHS.CREATE )
      self.obj1634.isGraphObjectVisual = True

      if(hasattr(self.obj1634, '_setHierarchicalLink')):
        self.obj1634._setHierarchicalLink(False)

      self.obj1634.GGLabel.setValue(7)
      self.obj1634.GGPivot.setValue(('True', 0))
      self.obj1634.GGPivot.config = 0
      self.obj1634.GGSubTypeMatching.setValue(('True', 0))
      self.obj1634.GGSubTypeMatching.config = 0
      self.obj1634.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(200.0,130.0,self.obj1634)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1634.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1634)
      self.obj1634.postAction( self.LHS.CREATE )

      self.obj1635=ToSameCircle(parent)
      self.obj1635.preAction( self.LHS.CREATE )
      self.obj1635.isGraphObjectVisual = True

      if(hasattr(self.obj1635, '_setHierarchicalLink')):
        self.obj1635._setHierarchicalLink(False)

      self.obj1635.GGLabel.setValue(5)
      self.obj1635.GGPivot.setValue(('True', 0))
      self.obj1635.GGPivot.config = 0
      self.obj1635.GGSubTypeMatching.setValue(('True', 0))
      self.obj1635.GGSubTypeMatching.config = 0
      self.obj1635.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(130.0,160.0,self.obj1635)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1635.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1635)
      self.obj1635.postAction( self.LHS.CREATE )

      self.obj1631.out_connections_.append(self.obj1635)
      self.obj1635.in_connections_.append(self.obj1631)
      self.obj1631.graphObject_.pendingConnections.append((self.obj1631.graphObject_.tag, self.obj1635.graphObject_.tag, [60.0, 160.0, 130.0, 160.0], 0, True))
      self.obj1631.out_connections_.append(self.obj1633)
      self.obj1633.in_connections_.append(self.obj1631)
      self.obj1631.graphObject_.pendingConnections.append((self.obj1631.graphObject_.tag, self.obj1633.graphObject_.tag, [60.0, 160.0, 60.0, 130.0], 0, True))
      self.obj1632.out_connections_.append(self.obj1634)
      self.obj1634.in_connections_.append(self.obj1632)
      self.obj1632.graphObject_.pendingConnections.append((self.obj1632.graphObject_.tag, self.obj1634.graphObject_.tag, [200.0, 160.0, 200.0, 130.0], 0, True))
      self.obj1633.out_connections_.append(self.obj1629)
      self.obj1629.in_connections_.append(self.obj1633)
      self.obj1633.graphObject_.pendingConnections.append((self.obj1633.graphObject_.tag, self.obj1629.graphObject_.tag, [60.0, 100.0, 60.0, 130.0], 0, True))
      self.obj1634.out_connections_.append(self.obj1630)
      self.obj1630.in_connections_.append(self.obj1634)
      self.obj1634.graphObject_.pendingConnections.append((self.obj1634.graphObject_.tag, self.obj1630.graphObject_.tag, [200.0, 100.0, 200.0, 130.0], 0, True))
      self.obj1635.out_connections_.append(self.obj1632)
      self.obj1632.in_connections_.append(self.obj1635)
      self.obj1635.graphObject_.pendingConnections.append((self.obj1635.graphObject_.tag, self.obj1632.graphObject_.tag, [200.0, 160.0, 130.0, 160.0], 0, True))

      self.RHS = ASG_AntWorld(parent)

      self.obj1637=GridNode(parent)
      self.obj1637.preAction( self.RHS.CREATE )
      self.obj1637.isGraphObjectVisual = True

      if(hasattr(self.obj1637, '_setHierarchicalLink')):
        self.obj1637._setHierarchicalLink(False)

      # foodParts
      self.obj1637.foodParts.setNone()

      # pheromones
      self.obj1637.pheromones.setNone()

      self.obj1637.GGLabel.setValue(1)
      self.obj1637.GGPivot.setValue(('True', 0))
      self.obj1637.GGPivot.config = 0
      self.obj1637.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(60.0,100.0,self.obj1637)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1637.graphObject_ = new_obj
      self.obj16370= AttrCalc()
      self.obj16370.Copy=ATOM3Boolean()
      self.obj16370.Copy.setValue(('Copy from LHS', 1))
      self.obj16370.Copy.config = 0
      self.obj16370.Specify=ATOM3Constraint()
      self.obj16370.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1637.GGset2Any['foodParts']= self.obj16370
      self.obj16371= AttrCalc()
      self.obj16371.Copy=ATOM3Boolean()
      self.obj16371.Copy.setValue(('Copy from LHS', 1))
      self.obj16371.Copy.config = 0
      self.obj16371.Specify=ATOM3Constraint()
      self.obj16371.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1637.GGset2Any['pheromones']= self.obj16371

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1637)
      self.obj1637.postAction( self.RHS.CREATE )

      self.obj1638=GridNode(parent)
      self.obj1638.preAction( self.RHS.CREATE )
      self.obj1638.isGraphObjectVisual = True

      if(hasattr(self.obj1638, '_setHierarchicalLink')):
        self.obj1638._setHierarchicalLink(False)

      # foodParts
      self.obj1638.foodParts.setNone()

      # pheromones
      self.obj1638.pheromones.setNone()

      self.obj1638.GGLabel.setValue(2)
      self.obj1638.GGPivot.setValue(('True', 0))
      self.obj1638.GGPivot.config = 0
      self.obj1638.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,100.0,self.obj1638)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1638.graphObject_ = new_obj
      self.obj16380= AttrCalc()
      self.obj16380.Copy=ATOM3Boolean()
      self.obj16380.Copy.setValue(('Copy from LHS', 1))
      self.obj16380.Copy.config = 0
      self.obj16380.Specify=ATOM3Constraint()
      self.obj16380.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1638.GGset2Any['foodParts']= self.obj16380
      self.obj16381= AttrCalc()
      self.obj16381.Copy=ATOM3Boolean()
      self.obj16381.Copy.setValue(('Copy from LHS', 1))
      self.obj16381.Copy.config = 0
      self.obj16381.Specify=ATOM3Constraint()
      self.obj16381.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1638.GGset2Any['pheromones']= self.obj16381

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1638)
      self.obj1638.postAction( self.RHS.CREATE )

      self.obj1639=GridNode(parent)
      self.obj1639.preAction( self.RHS.CREATE )
      self.obj1639.isGraphObjectVisual = True

      if(hasattr(self.obj1639, '_setHierarchicalLink')):
        self.obj1639._setHierarchicalLink(False)

      # foodParts
      self.obj1639.foodParts.setNone()

      # pheromones
      self.obj1639.pheromones.setNone()

      self.obj1639.GGLabel.setValue(3)
      self.obj1639.GGPivot.setValue(('True', 0))
      self.obj1639.GGPivot.config = 0
      self.obj1639.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(60.0,160.0,self.obj1639)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1639.graphObject_ = new_obj
      self.obj16390= AttrCalc()
      self.obj16390.Copy=ATOM3Boolean()
      self.obj16390.Copy.setValue(('Copy from LHS', 1))
      self.obj16390.Copy.config = 0
      self.obj16390.Specify=ATOM3Constraint()
      self.obj16390.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1639.GGset2Any['foodParts']= self.obj16390
      self.obj16391= AttrCalc()
      self.obj16391.Copy=ATOM3Boolean()
      self.obj16391.Copy.setValue(('Copy from LHS', 1))
      self.obj16391.Copy.config = 0
      self.obj16391.Specify=ATOM3Constraint()
      self.obj16391.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1639.GGset2Any['pheromones']= self.obj16391

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1639)
      self.obj1639.postAction( self.RHS.CREATE )

      self.obj1640=GridNode(parent)
      self.obj1640.preAction( self.RHS.CREATE )
      self.obj1640.isGraphObjectVisual = True

      if(hasattr(self.obj1640, '_setHierarchicalLink')):
        self.obj1640._setHierarchicalLink(False)

      # foodParts
      self.obj1640.foodParts.setNone()

      # pheromones
      self.obj1640.pheromones.setNone()

      self.obj1640.GGLabel.setValue(4)
      self.obj1640.GGPivot.setValue(('True', 0))
      self.obj1640.GGPivot.config = 0
      self.obj1640.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,160.0,self.obj1640)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1640.graphObject_ = new_obj
      self.obj16400= AttrCalc()
      self.obj16400.Copy=ATOM3Boolean()
      self.obj16400.Copy.setValue(('Copy from LHS', 1))
      self.obj16400.Copy.config = 0
      self.obj16400.Specify=ATOM3Constraint()
      self.obj16400.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1640.GGset2Any['foodParts']= self.obj16400
      self.obj16401= AttrCalc()
      self.obj16401.Copy=ATOM3Boolean()
      self.obj16401.Copy.setValue(('Copy from LHS', 1))
      self.obj16401.Copy.config = 0
      self.obj16401.Specify=ATOM3Constraint()
      self.obj16401.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1640.GGset2Any['pheromones']= self.obj16401

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1640)
      self.obj1640.postAction( self.RHS.CREATE )

      self.obj1641=ToNextCircle(parent)
      self.obj1641.preAction( self.RHS.CREATE )
      self.obj1641.isGraphObjectVisual = True

      if(hasattr(self.obj1641, '_setHierarchicalLink')):
        self.obj1641._setHierarchicalLink(False)

      self.obj1641.GGLabel.setValue(6)
      self.obj1641.GGPivot.setValue(('True', 0))
      self.obj1641.GGPivot.config = 0
      self.obj1641.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(60.0,130.0,self.obj1641)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1641.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1641)
      self.obj1641.postAction( self.RHS.CREATE )

      self.obj1642=ToNextCircle(parent)
      self.obj1642.preAction( self.RHS.CREATE )
      self.obj1642.isGraphObjectVisual = True

      if(hasattr(self.obj1642, '_setHierarchicalLink')):
        self.obj1642._setHierarchicalLink(False)

      self.obj1642.GGLabel.setValue(7)
      self.obj1642.GGPivot.setValue(('True', 0))
      self.obj1642.GGPivot.config = 0
      self.obj1642.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(200.0,130.0,self.obj1642)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1642.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1642)
      self.obj1642.postAction( self.RHS.CREATE )

      self.obj1643=ToSameCircle(parent)
      self.obj1643.preAction( self.RHS.CREATE )
      self.obj1643.isGraphObjectVisual = True

      if(hasattr(self.obj1643, '_setHierarchicalLink')):
        self.obj1643._setHierarchicalLink(False)

      self.obj1643.GGLabel.setValue(5)
      self.obj1643.GGPivot.setValue(('True', 0))
      self.obj1643.GGPivot.config = 0
      self.obj1643.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(130.0,160.0,self.obj1643)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1643.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1643)
      self.obj1643.postAction( self.RHS.CREATE )

      self.obj1644=ToSameCircle(parent)
      self.obj1644.preAction( self.RHS.CREATE )
      self.obj1644.isGraphObjectVisual = True

      if(hasattr(self.obj1644, '_setHierarchicalLink')):
        self.obj1644._setHierarchicalLink(False)

      self.obj1644.GGLabel.setValue(8)
      self.obj1644.GGPivot.setValue(('True', 0))
      self.obj1644.GGPivot.config = 0
      self.obj1644.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(130.0,100.0,self.obj1644)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1644.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1644)
      self.obj1644.postAction( self.RHS.CREATE )

      self.obj1637.out_connections_.append(self.obj1644)
      self.obj1644.in_connections_.append(self.obj1637)
      self.obj1637.graphObject_.pendingConnections.append((self.obj1637.graphObject_.tag, self.obj1644.graphObject_.tag, [60.0, 100.0, 130.0, 100.0], 0, True))
      self.obj1639.out_connections_.append(self.obj1643)
      self.obj1643.in_connections_.append(self.obj1639)
      self.obj1639.graphObject_.pendingConnections.append((self.obj1639.graphObject_.tag, self.obj1643.graphObject_.tag, [60.0, 160.0, 130.0, 160.0], 2, 0))
      self.obj1639.out_connections_.append(self.obj1641)
      self.obj1641.in_connections_.append(self.obj1639)
      self.obj1639.graphObject_.pendingConnections.append((self.obj1639.graphObject_.tag, self.obj1641.graphObject_.tag, [60.0, 160.0, 60.0, 130.0], 2, 0))
      self.obj1640.out_connections_.append(self.obj1642)
      self.obj1642.in_connections_.append(self.obj1640)
      self.obj1640.graphObject_.pendingConnections.append((self.obj1640.graphObject_.tag, self.obj1642.graphObject_.tag, [200.0, 160.0, 200.0, 130.0], 2, 0))
      self.obj1641.out_connections_.append(self.obj1637)
      self.obj1637.in_connections_.append(self.obj1641)
      self.obj1641.graphObject_.pendingConnections.append((self.obj1641.graphObject_.tag, self.obj1637.graphObject_.tag, [60.0, 100.0, 60.0, 130.0], 2, 0))
      self.obj1642.out_connections_.append(self.obj1638)
      self.obj1638.in_connections_.append(self.obj1642)
      self.obj1642.graphObject_.pendingConnections.append((self.obj1642.graphObject_.tag, self.obj1638.graphObject_.tag, [200.0, 100.0, 200.0, 130.0], 2, 0))
      self.obj1643.out_connections_.append(self.obj1640)
      self.obj1640.in_connections_.append(self.obj1643)
      self.obj1643.graphObject_.pendingConnections.append((self.obj1643.graphObject_.tag, self.obj1640.graphObject_.tag, [200.0, 160.0, 130.0, 160.0], 2, 0))
      self.obj1644.out_connections_.append(self.obj1638)
      self.obj1638.in_connections_.append(self.obj1644)
      self.obj1644.graphObject_.pendingConnections.append((self.obj1644.graphObject_.tag, self.obj1638.graphObject_.tag, [200.0, 100.0, 130.0, 100.0], 0, True))

      self.NAC = ASG_AntWorld(parent)

      self.obj1646=GridNode(parent)
      self.obj1646.preAction( self.NAC.CREATE )
      self.obj1646.isGraphObjectVisual = True

      if(hasattr(self.obj1646, '_setHierarchicalLink')):
        self.obj1646._setHierarchicalLink(False)

      # foodParts
      self.obj1646.foodParts.setNone()

      # pheromones
      self.obj1646.pheromones.setNone()

      self.obj1646.GGLabel.setValue(1)
      self.obj1646.GGSubTypeMatching.setValue(('True', 0))
      self.obj1646.GGSubTypeMatching.config = 0
      self.obj1646.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(60.0,80.0,self.obj1646)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1646.graphObject_ = new_obj
      self.obj16460= AttrCalc()
      self.obj16460=ATOM3Boolean()
      self.obj16460.setValue(('Set to any', 1))
      self.obj16460.config = 0
      self.obj1646.GGset2Any['foodParts']= self.obj16460
      self.obj16461= AttrCalc()
      self.obj16461=ATOM3Boolean()
      self.obj16461.setValue(('Set to any', 1))
      self.obj16461.config = 0
      self.obj1646.GGset2Any['pheromones']= self.obj16461

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1646)
      self.obj1646.postAction( self.NAC.CREATE )

      self.obj1647=GridNode(parent)
      self.obj1647.preAction( self.NAC.CREATE )
      self.obj1647.isGraphObjectVisual = True

      if(hasattr(self.obj1647, '_setHierarchicalLink')):
        self.obj1647._setHierarchicalLink(False)

      # foodParts
      self.obj1647.foodParts.setNone()

      # pheromones
      self.obj1647.pheromones.setNone()

      self.obj1647.GGLabel.setValue(2)
      self.obj1647.GGSubTypeMatching.setValue(('True', 0))
      self.obj1647.GGSubTypeMatching.config = 0
      self.obj1647.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(160.0,80.0,self.obj1647)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1647.graphObject_ = new_obj
      self.obj16470= AttrCalc()
      self.obj16470=ATOM3Boolean()
      self.obj16470.setValue(('Set to any', 1))
      self.obj16470.config = 0
      self.obj1647.GGset2Any['foodParts']= self.obj16470
      self.obj16471= AttrCalc()
      self.obj16471=ATOM3Boolean()
      self.obj16471.setValue(('Set to any', 1))
      self.obj16471.config = 0
      self.obj1647.GGset2Any['pheromones']= self.obj16471

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1647)
      self.obj1647.postAction( self.NAC.CREATE )

      self.obj1648=ToSameCircle(parent)
      self.obj1648.preAction( self.NAC.CREATE )
      self.obj1648.isGraphObjectVisual = True

      if(hasattr(self.obj1648, '_setHierarchicalLink')):
        self.obj1648._setHierarchicalLink(False)

      self.obj1648.GGLabel.setValue(8)
      self.obj1648.GGSubTypeMatching.setValue(('True', 0))
      self.obj1648.GGSubTypeMatching.config = 0
      self.obj1648.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(117.0,87.0,self.obj1648)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1648.graphObject_ = new_obj

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1648)
      self.obj1648.postAction( self.NAC.CREATE )

      self.obj1646.out_connections_.append(self.obj1648)
      self.obj1648.in_connections_.append(self.obj1646)
      self.obj1646.graphObject_.pendingConnections.append((self.obj1646.graphObject_.tag, self.obj1648.graphObject_.tag, [60.0, 80.0, 116.99999999999999, 86.999999999999986], 2, 0))
      self.obj1648.out_connections_.append(self.obj1647)
      self.obj1647.in_connections_.append(self.obj1648)
      self.obj1648.graphObject_.pendingConnections.append((self.obj1648.graphObject_.tag, self.obj1647.graphObject_.tag, [160.0, 80.0, 116.99999999999999, 86.999999999999986], 2, 0))

   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      for conn in node.out_connections_:
          if isinstance(conn, ToSameCircle):
              return False
      return True
      

   def action(self, graphID, isograph, atom3i):
      pass

