# _ generateMainAxisNode_GG_rule.py ____________________________________________________________________________
# File generated automatically by ATOM3. Graph Grammar Rule
# ___________________________________________________________________________________________
from GGrule import *
from MainAxisNode import *
from GoOn import *
from Ant import *
from ToSameCircle import *
from Hill import *
from ToNextCircle import *
from World import *
from ASG_AntWorld import *
from GridNode import *
class generateMainAxisNode_GG_rule (GGrule):

   def __init__(self, parent):
      GGrule.__init__(self, 1)
      self.TimeDelay = ATOM3Integer(2)
      self.exactMatch = 1
      self.TestRule = 1
      self.LHS = ASG_AntWorld(parent)

      self.obj1550=GridNode(parent)
      self.obj1550.preAction( self.LHS.CREATE )
      self.obj1550.isGraphObjectVisual = True

      if(hasattr(self.obj1550, '_setHierarchicalLink')):
        self.obj1550._setHierarchicalLink(False)

      # foodParts
      self.obj1550.foodParts.setNone()

      # pheromones
      self.obj1550.pheromones.setNone()

      self.obj1550.GGLabel.setValue(2)
      self.obj1550.GGPivot.setValue(('True', 1))
      self.obj1550.GGPivot.config = 0
      self.obj1550.GGSubTypeMatching.setValue(('True', 1))
      self.obj1550.GGSubTypeMatching.config = 0
      self.obj1550.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(120.0,60.0,self.obj1550)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1550.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1550)
      self.obj1550.postAction( self.LHS.CREATE )

      self.obj1551=MainAxisNode(parent)
      self.obj1551.preAction( self.LHS.CREATE )
      self.obj1551.isGraphObjectVisual = True

      if(hasattr(self.obj1551, '_setHierarchicalLink')):
        self.obj1551._setHierarchicalLink(False)

      # foodParts
      self.obj1551.foodParts.setNone()

      # pheromones
      self.obj1551.pheromones.setNone()

      self.obj1551.GGLabel.setValue(1)
      self.obj1551.GGPivot.setValue(('True', 0))
      self.obj1551.GGPivot.config = 0
      self.obj1551.GGSubTypeMatching.setValue(('True', 0))
      self.obj1551.GGSubTypeMatching.config = 0
      self.obj1551.graphClass_= graph_MainAxisNode
      if parent.genGraphics:
         new_obj = graph_GridNode(260.0,60.0,self.obj1551)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1551.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1551)
      self.obj1551.postAction( self.LHS.CREATE )

      self.obj1552=ToSameCircle(parent)
      self.obj1552.preAction( self.LHS.CREATE )
      self.obj1552.isGraphObjectVisual = True

      if(hasattr(self.obj1552, '_setHierarchicalLink')):
        self.obj1552._setHierarchicalLink(False)

      self.obj1552.GGLabel.setValue(3)
      self.obj1552.GGPivot.setValue(('True', 0))
      self.obj1552.GGPivot.config = 0
      self.obj1552.GGSubTypeMatching.setValue(('True', 0))
      self.obj1552.GGSubTypeMatching.config = 0
      self.obj1552.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(120.0,60.0,self.obj1552)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1552.graphObject_ = new_obj

      # Add node to the root: self.LHS
      self.LHS.addNode(self.obj1552)
      self.obj1552.postAction( self.LHS.CREATE )

      self.obj1550.out_connections_.append(self.obj1552)
      self.obj1552.in_connections_.append(self.obj1550)
      self.obj1550.graphObject_.pendingConnections.append((self.obj1550.graphObject_.tag, self.obj1552.graphObject_.tag, [120.0, 60.0, 120.0, 60.0], 0, False))
      self.obj1552.out_connections_.append(self.obj1551)
      self.obj1551.in_connections_.append(self.obj1552)
      self.obj1552.graphObject_.pendingConnections.append((self.obj1552.graphObject_.tag, self.obj1551.graphObject_.tag, [260.0, 60.0, 120.0, 60.0], 0, False))

      self.RHS = ASG_AntWorld(parent)

      self.obj1554=GridNode(parent)
      self.obj1554.preAction( self.RHS.CREATE )
      self.obj1554.isGraphObjectVisual = True

      if(hasattr(self.obj1554, '_setHierarchicalLink')):
        self.obj1554._setHierarchicalLink(False)

      # foodParts
      self.obj1554.foodParts.setValue(0)

      # pheromones
      self.obj1554.pheromones.setValue(0)

      self.obj1554.GGLabel.setValue(2)
      self.obj1554.GGPivot.setValue(('True', 0))
      self.obj1554.GGPivot.config = 0
      self.obj1554.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(100.0,60.0,self.obj1554)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1554.graphObject_ = new_obj
      self.obj15540= AttrCalc()
      self.obj15540.Copy=ATOM3Boolean()
      self.obj15540.Copy.setValue(('Copy from LHS', 1))
      self.obj15540.Copy.config = 0
      self.obj15540.Specify=ATOM3Constraint()
      self.obj15540.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1554.GGset2Any['foodParts']= self.obj15540
      self.obj15541= AttrCalc()
      self.obj15541.Copy=ATOM3Boolean()
      self.obj15541.Copy.setValue(('Copy from LHS', 1))
      self.obj15541.Copy.config = 0
      self.obj15541.Specify=ATOM3Constraint()
      self.obj15541.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1554.GGset2Any['pheromones']= self.obj15541

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1554)
      self.obj1554.postAction( self.RHS.CREATE )

      self.obj1555=GridNode(parent)
      self.obj1555.preAction( self.RHS.CREATE )
      self.obj1555.isGraphObjectVisual = True

      if(hasattr(self.obj1555, '_setHierarchicalLink')):
        self.obj1555._setHierarchicalLink(False)

      # foodParts
      self.obj1555.foodParts.setValue(0)

      # pheromones
      self.obj1555.pheromones.setValue(0)

      self.obj1555.GGLabel.setValue(4)
      self.obj1555.GGPivot.setValue(('True', 0))
      self.obj1555.GGPivot.config = 0
      self.obj1555.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(100.0,120.0,self.obj1555)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1555.graphObject_ = new_obj
      self.obj15550= AttrCalc()
      self.obj15550.Copy=ATOM3Boolean()
      self.obj15550.Copy.setValue(('Copy from LHS', 0))
      self.obj15550.Copy.config = 0
      self.obj15550.Specify=ATOM3Constraint()
      self.obj15550.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1555.GGset2Any['foodParts']= self.obj15550
      self.obj15551= AttrCalc()
      self.obj15551.Copy=ATOM3Boolean()
      self.obj15551.Copy.setValue(('Copy from LHS', 0))
      self.obj15551.Copy.config = 0
      self.obj15551.Specify=ATOM3Constraint()
      self.obj15551.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1555.GGset2Any['pheromones']= self.obj15551

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1555)
      self.obj1555.postAction( self.RHS.CREATE )

      self.obj1556=GridNode(parent)
      self.obj1556.preAction( self.RHS.CREATE )
      self.obj1556.isGraphObjectVisual = True

      if(hasattr(self.obj1556, '_setHierarchicalLink')):
        self.obj1556._setHierarchicalLink(False)

      # foodParts
      self.obj1556.foodParts.setValue(0)

      # pheromones
      self.obj1556.pheromones.setValue(0)

      self.obj1556.GGLabel.setValue(6)
      self.obj1556.GGPivot.setValue(('True', 0))
      self.obj1556.GGPivot.config = 0
      self.obj1556.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(280.0,120.0,self.obj1556)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1556.graphObject_ = new_obj
      self.obj15560= AttrCalc()
      self.obj15560.Copy=ATOM3Boolean()
      self.obj15560.Copy.setValue(('Copy from LHS', 0))
      self.obj15560.Copy.config = 0
      self.obj15560.Specify=ATOM3Constraint()
      self.obj15560.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1556.GGset2Any['foodParts']= self.obj15560
      self.obj15561= AttrCalc()
      self.obj15561.Copy=ATOM3Boolean()
      self.obj15561.Copy.setValue(('Copy from LHS', 0))
      self.obj15561.Copy.config = 0
      self.obj15561.Specify=ATOM3Constraint()
      self.obj15561.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1556.GGset2Any['pheromones']= self.obj15561

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1556)
      self.obj1556.postAction( self.RHS.CREATE )

      self.obj1557=MainAxisNode(parent)
      self.obj1557.preAction( self.RHS.CREATE )
      self.obj1557.isGraphObjectVisual = True

      if(hasattr(self.obj1557, '_setHierarchicalLink')):
        self.obj1557._setHierarchicalLink(False)

      # foodParts
      self.obj1557.foodParts.setValue(0)

      # pheromones
      self.obj1557.pheromones.setValue(0)

      self.obj1557.GGLabel.setValue(1)
      self.obj1557.GGPivot.setValue(('True', 1))
      self.obj1557.GGPivot.config = 0
      self.obj1557.graphClass_= graph_MainAxisNode
      if parent.genGraphics:
         new_obj = graph_GridNode(240.0,60.0,self.obj1557)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1557.graphObject_ = new_obj
      self.obj15570= AttrCalc()
      self.obj15570.Copy=ATOM3Boolean()
      self.obj15570.Copy.setValue(('Copy from LHS', 1))
      self.obj15570.Copy.config = 0
      self.obj15570.Specify=ATOM3Constraint()
      self.obj15570.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1557.GGset2Any['foodParts']= self.obj15570
      self.obj15571= AttrCalc()
      self.obj15571.Copy=ATOM3Boolean()
      self.obj15571.Copy.setValue(('Copy from LHS', 1))
      self.obj15571.Copy.config = 0
      self.obj15571.Specify=ATOM3Constraint()
      self.obj15571.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1557.GGset2Any['pheromones']= self.obj15571

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1557)
      self.obj1557.postAction( self.RHS.CREATE )

      self.obj1558=MainAxisNode(parent)
      self.obj1558.preAction( self.RHS.CREATE )
      self.obj1558.isGraphObjectVisual = True

      if(hasattr(self.obj1558, '_setHierarchicalLink')):
        self.obj1558._setHierarchicalLink(False)

      # foodParts
      self.obj1558.foodParts.setValue(0)

      # pheromones
      self.obj1558.pheromones.setValue(0)

      self.obj1558.GGLabel.setValue(5)
      self.obj1558.GGPivot.setValue(('True', 0))
      self.obj1558.GGPivot.config = 0
      self.obj1558.graphClass_= graph_MainAxisNode
      if parent.genGraphics:
         new_obj = graph_GridNode(200.0,120.0,self.obj1558)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1558.graphObject_ = new_obj
      self.obj15580= AttrCalc()
      self.obj15580.Copy=ATOM3Boolean()
      self.obj15580.Copy.setValue(('Copy from LHS', 0))
      self.obj15580.Copy.config = 0
      self.obj15580.Specify=ATOM3Constraint()
      self.obj15580.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1558.GGset2Any['foodParts']= self.obj15580
      self.obj15581= AttrCalc()
      self.obj15581.Copy=ATOM3Boolean()
      self.obj15581.Copy.setValue(('Copy from LHS', 0))
      self.obj15581.Copy.config = 0
      self.obj15581.Specify=ATOM3Constraint()
      self.obj15581.Specify.setValue(('AttrSpecify', (['Python', 'OCL'], 0), (['PREcondition', 'POSTcondition'], 1), (['EDIT', 'SAVE', 'CREATE', 'CONNECT', 'DELETE', 'DISCONNECT', 'TRANSFORM', 'SELECT', 'DRAG', 'DROP', 'MOVE'], [0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]), None))
      self.obj1558.GGset2Any['pheromones']= self.obj15581

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1558)
      self.obj1558.postAction( self.RHS.CREATE )

      self.obj1559=ToNextCircle(parent)
      self.obj1559.preAction( self.RHS.CREATE )
      self.obj1559.isGraphObjectVisual = True

      if(hasattr(self.obj1559, '_setHierarchicalLink')):
        self.obj1559._setHierarchicalLink(False)

      self.obj1559.GGLabel.setValue(7)
      self.obj1559.GGPivot.setValue(('True', 0))
      self.obj1559.GGPivot.config = 0
      self.obj1559.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(240.0,60.0,self.obj1559)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1559.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1559)
      self.obj1559.postAction( self.RHS.CREATE )

      self.obj1560=ToNextCircle(parent)
      self.obj1560.preAction( self.RHS.CREATE )
      self.obj1560.isGraphObjectVisual = True

      if(hasattr(self.obj1560, '_setHierarchicalLink')):
        self.obj1560._setHierarchicalLink(False)

      self.obj1560.GGLabel.setValue(8)
      self.obj1560.GGPivot.setValue(('True', 0))
      self.obj1560.GGPivot.config = 0
      self.obj1560.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(240.0,60.0,self.obj1560)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1560.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1560)
      self.obj1560.postAction( self.RHS.CREATE )

      self.obj1561=ToNextCircle(parent)
      self.obj1561.preAction( self.RHS.CREATE )
      self.obj1561.isGraphObjectVisual = True

      if(hasattr(self.obj1561, '_setHierarchicalLink')):
        self.obj1561._setHierarchicalLink(False)

      self.obj1561.GGLabel.setValue(9)
      self.obj1561.GGPivot.setValue(('True', 0))
      self.obj1561.GGPivot.config = 0
      self.obj1561.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(240.0,60.0,self.obj1561)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1561.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1561)
      self.obj1561.postAction( self.RHS.CREATE )

      self.obj1562=ToSameCircle(parent)
      self.obj1562.preAction( self.RHS.CREATE )
      self.obj1562.isGraphObjectVisual = True

      if(hasattr(self.obj1562, '_setHierarchicalLink')):
        self.obj1562._setHierarchicalLink(False)

      self.obj1562.GGLabel.setValue(3)
      self.obj1562.GGPivot.setValue(('True', 0))
      self.obj1562.GGPivot.config = 0
      self.obj1562.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(100.0,60.0,self.obj1562)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1562.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1562)
      self.obj1562.postAction( self.RHS.CREATE )

      self.obj1563=ToSameCircle(parent)
      self.obj1563.preAction( self.RHS.CREATE )
      self.obj1563.isGraphObjectVisual = True

      if(hasattr(self.obj1563, '_setHierarchicalLink')):
        self.obj1563._setHierarchicalLink(False)

      self.obj1563.GGLabel.setValue(10)
      self.obj1563.GGPivot.setValue(('True', 0))
      self.obj1563.GGPivot.config = 0
      self.obj1563.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(100.0,120.0,self.obj1563)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1563.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1563)
      self.obj1563.postAction( self.RHS.CREATE )

      self.obj1564=ToSameCircle(parent)
      self.obj1564.preAction( self.RHS.CREATE )
      self.obj1564.isGraphObjectVisual = True

      if(hasattr(self.obj1564, '_setHierarchicalLink')):
        self.obj1564._setHierarchicalLink(False)

      self.obj1564.GGLabel.setValue(11)
      self.obj1564.GGPivot.setValue(('True', 0))
      self.obj1564.GGPivot.config = 0
      self.obj1564.graphClass_= graph_ToSameCircle
      if parent.genGraphics:
         new_obj = graph_ToSameCircle(200.0,120.0,self.obj1564)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1564.graphObject_ = new_obj

      # Add node to the root: self.RHS
      self.RHS.addNode(self.obj1564)
      self.obj1564.postAction( self.RHS.CREATE )

      self.obj1554.out_connections_.append(self.obj1562)
      self.obj1562.in_connections_.append(self.obj1554)
      self.obj1554.graphObject_.pendingConnections.append((self.obj1554.graphObject_.tag, self.obj1562.graphObject_.tag, [100.0, 60.0, 100.0, 60.0], 0, False))
      self.obj1555.out_connections_.append(self.obj1563)
      self.obj1563.in_connections_.append(self.obj1555)
      self.obj1555.graphObject_.pendingConnections.append((self.obj1555.graphObject_.tag, self.obj1563.graphObject_.tag, [100.0, 120.0, 100.0, 120.0], 0, False))
      self.obj1557.out_connections_.append(self.obj1559)
      self.obj1559.in_connections_.append(self.obj1557)
      self.obj1557.graphObject_.pendingConnections.append((self.obj1557.graphObject_.tag, self.obj1559.graphObject_.tag, [240.0, 60.0, 240.0, 60.0], 0, False))
      self.obj1557.out_connections_.append(self.obj1560)
      self.obj1560.in_connections_.append(self.obj1557)
      self.obj1557.graphObject_.pendingConnections.append((self.obj1557.graphObject_.tag, self.obj1560.graphObject_.tag, [240.0, 60.0, 240.0, 60.0], 0, False))
      self.obj1557.out_connections_.append(self.obj1561)
      self.obj1561.in_connections_.append(self.obj1557)
      self.obj1557.graphObject_.pendingConnections.append((self.obj1557.graphObject_.tag, self.obj1561.graphObject_.tag, [240.0, 60.0, 240.0, 60.0], 0, False))
      self.obj1558.out_connections_.append(self.obj1564)
      self.obj1564.in_connections_.append(self.obj1558)
      self.obj1558.graphObject_.pendingConnections.append((self.obj1558.graphObject_.tag, self.obj1564.graphObject_.tag, [200.0, 120.0, 200.0, 120.0], 0, False))
      self.obj1559.out_connections_.append(self.obj1555)
      self.obj1555.in_connections_.append(self.obj1559)
      self.obj1559.graphObject_.pendingConnections.append((self.obj1559.graphObject_.tag, self.obj1555.graphObject_.tag, [100.0, 120.0, 240.0, 60.0], 0, False))
      self.obj1560.out_connections_.append(self.obj1558)
      self.obj1558.in_connections_.append(self.obj1560)
      self.obj1560.graphObject_.pendingConnections.append((self.obj1560.graphObject_.tag, self.obj1558.graphObject_.tag, [200.0, 120.0, 240.0, 60.0], 0, False))
      self.obj1561.out_connections_.append(self.obj1556)
      self.obj1556.in_connections_.append(self.obj1561)
      self.obj1561.graphObject_.pendingConnections.append((self.obj1561.graphObject_.tag, self.obj1556.graphObject_.tag, [280.0, 120.0, 240.0, 60.0], 0, False))
      self.obj1562.out_connections_.append(self.obj1557)
      self.obj1557.in_connections_.append(self.obj1562)
      self.obj1562.graphObject_.pendingConnections.append((self.obj1562.graphObject_.tag, self.obj1557.graphObject_.tag, [240.0, 60.0, 100.0, 60.0], 0, False))
      self.obj1563.out_connections_.append(self.obj1558)
      self.obj1558.in_connections_.append(self.obj1563)
      self.obj1563.graphObject_.pendingConnections.append((self.obj1563.graphObject_.tag, self.obj1558.graphObject_.tag, [200.0, 120.0, 100.0, 120.0], 0, False))
      self.obj1564.out_connections_.append(self.obj1556)
      self.obj1556.in_connections_.append(self.obj1564)
      self.obj1564.graphObject_.pendingConnections.append((self.obj1564.graphObject_.tag, self.obj1556.graphObject_.tag, [280.0, 120.0, 200.0, 120.0], 0, False))

      self.NAC = ASG_AntWorld(parent)

      self.obj1566=GridNode(parent)
      self.obj1566.preAction( self.NAC.CREATE )
      self.obj1566.isGraphObjectVisual = True

      if(hasattr(self.obj1566, '_setHierarchicalLink')):
        self.obj1566._setHierarchicalLink(False)

      # foodParts
      self.obj1566.foodParts.setNone()

      # pheromones
      self.obj1566.pheromones.setNone()

      self.obj1566.GGLabel.setValue(4)
      self.obj1566.GGSubTypeMatching.setValue(('True', 0))
      self.obj1566.GGSubTypeMatching.config = 0
      self.obj1566.graphClass_= graph_GridNode
      if parent.genGraphics:
         new_obj = graph_GridNode(240.0,120.0,self.obj1566)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1566.graphObject_ = new_obj
      self.obj15660= AttrCalc()
      self.obj15660=ATOM3Boolean()
      self.obj15660.setValue(('Set to any', 1))
      self.obj15660.config = 0
      self.obj1566.GGset2Any['foodParts']= self.obj15660
      self.obj15661= AttrCalc()
      self.obj15661=ATOM3Boolean()
      self.obj15661.setValue(('Set to any', 1))
      self.obj15661.config = 0
      self.obj1566.GGset2Any['pheromones']= self.obj15661

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1566)
      self.obj1566.postAction( self.NAC.CREATE )

      self.obj1567=MainAxisNode(parent)
      self.obj1567.preAction( self.NAC.CREATE )
      self.obj1567.isGraphObjectVisual = True

      if(hasattr(self.obj1567, '_setHierarchicalLink')):
        self.obj1567._setHierarchicalLink(False)

      # foodParts
      self.obj1567.foodParts.setNone()

      # pheromones
      self.obj1567.pheromones.setNone()

      self.obj1567.GGLabel.setValue(1)
      self.obj1567.GGSubTypeMatching.setValue(('True', 0))
      self.obj1567.GGSubTypeMatching.config = 0
      self.obj1567.graphClass_= graph_MainAxisNode
      if parent.genGraphics:
         new_obj = graph_GridNode(240.0,40.0,self.obj1567)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
         new_obj.layConstraints['scale'] = [1.0, 1.0]
      else: new_obj = None
      self.obj1567.graphObject_ = new_obj
      self.obj15670= AttrCalc()
      self.obj15670=ATOM3Boolean()
      self.obj15670.setValue(('Set to any', 1))
      self.obj15670.config = 0
      self.obj1567.GGset2Any['foodParts']= self.obj15670
      self.obj15671= AttrCalc()
      self.obj15671=ATOM3Boolean()
      self.obj15671.setValue(('Set to any', 1))
      self.obj15671.config = 0
      self.obj1567.GGset2Any['pheromones']= self.obj15671

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1567)
      self.obj1567.postAction( self.NAC.CREATE )

      self.obj1568=ToNextCircle(parent)
      self.obj1568.preAction( self.NAC.CREATE )
      self.obj1568.isGraphObjectVisual = True

      if(hasattr(self.obj1568, '_setHierarchicalLink')):
        self.obj1568._setHierarchicalLink(False)

      self.obj1568.GGLabel.setValue(5)
      self.obj1568.GGSubTypeMatching.setValue(('True', 0))
      self.obj1568.GGSubTypeMatching.config = 0
      self.obj1568.graphClass_= graph_ToNextCircle
      if parent.genGraphics:
         new_obj = graph_ToNextCircle(240.0,40.0,self.obj1568)
         new_obj.layConstraints = dict() # Graphical Layout Constraints 
      else: new_obj = None
      self.obj1568.graphObject_ = new_obj

      # Add node to the root: self.NAC
      self.NAC.addNode(self.obj1568)
      self.obj1568.postAction( self.NAC.CREATE )

      self.obj1567.out_connections_.append(self.obj1568)
      self.obj1568.in_connections_.append(self.obj1567)
      self.obj1567.graphObject_.pendingConnections.append((self.obj1567.graphObject_.tag, self.obj1568.graphObject_.tag, [240.0, 40.0, 240.0, 40.0], 0, False))
      self.obj1568.out_connections_.append(self.obj1566)
      self.obj1566.in_connections_.append(self.obj1568)
      self.obj1568.graphObject_.pendingConnections.append((self.obj1568.graphObject_.tag, self.obj1566.graphObject_.tag, [240.0, 120.0, 240.0, 40.0], 0, False))

   def condition(self, graphID, isograph, atom3i):
      node = self.getMatched(graphID, self.LHS.nodeWithLabel(1))
      for conn in node.out_connections_:
          if isinstance(conn, ToNextCircle):
              return False
      return True
      

   def action(self, graphID, isograph, atom3i):
      pass

